////////////////////////////////////////////////////////////////////////////////////
//  Any questions, comments, or suggestions?  ..Visit us at: http://aigaming.net  //
////////////////////////////////////////////////////////////////////////////////////

init()	// based on mod by NC-17, completely re-coded by me :)
{
	if (isDefined(game["gamestarted"]))	  // no changes between rounds..
	{
		if (isDefined(game["svrAdminCmd"]) && game["svrAdminCmd"])
			thread start();

		return;
	}

	name = getcvar("gamename");
	if (name == "Call of Duty")
		game["svrGameName"] = "cod";
	else if (name == "Call of Duty 2")
		game["svrGameName"] = "cod2";
	else
		game["svrGameName"] = "uo";

	game["svrAdminCmd"] = svr\utils::cvardef("svr_admincommands", 0, 0, 1, "int");

	if (!game["svrAdminCmd"])	return;

	if (game["svrGameName"] == "cod2")
	{
		game["adminLocalMsg"]	= svr\utils::cvardef("svr_admin_localized", 1, 0, 1, "int");
		game["adminEffect"]["mortar"][0]	= loadfx("fx/explosions/mortarExp_beach.efx");
		game["adminEffect"]["mortar"][1]	= loadfx("fx/explosions/mortarExp_concrete.efx");
		game["adminEffect"]["mortar"][2]	= loadfx("fx/explosions/mortarExp_dirt.efx");
		game["adminEffect"]["mortar"][3]	= loadfx("fx/explosions/mortarExp_mud.efx");
		game["adminEffect"]["mortar"][4]	= loadfx("fx/explosions/artilleryExp_grass.efx");
		game["adminEffect"]["explode"]		= loadfx("fx/explosions/default_explosion.efx");
		game["adminEffect"]["burn"]			= loadfx("fx/fire/character_torso_fire.efx");
		game["adminEffect"]["smoke"]		= loadfx("fx/smoke/grenade_smoke.efx");
		game["deadCowModel"] = "xmodel/cow_dead_1";
	}
	else
	{
		game["adminLocalMsg"]	= false;
		game["adminEffect"]["mortar"][0]	= loadfx("fx/impacts/newimps/minefield.efx");
		game["adminEffect"]["mortar"][1]	= loadfx("fx/impacts/newimps/minefield.efx");
		game["adminEffect"]["mortar"][2]	= loadfx("fx/impacts/dirthit_mortar.efx");
		game["adminEffect"]["mortar"][3]	= loadfx("fx/impacts/newimps/blast_gen3.efx");
		game["adminEffect"]["mortar"][4]	= loadfx("fx/impacts/newimps/dirthit_mortar2daymarked.efx");
		game["adminEffect"]["burn"]			= loadfx("fx/fire/fireheavysmoke.efx");
		game["adminEffect"]["explode"]		= loadfx("fx/explosions/pathfinder_explosion.efx");
		game["adminEffect"]["smoke"]		= loadfx("fx/tagged/flameout.efx");
		game["deadCowModel"] = "xmodel/cow_dead";
		precachemodel("xmodel/cow_standing");
	}

	precachemodel(game["deadCowModel"]);

	thread start();
}

start()
{
	level endon("svrKillThread");

	for (;;)
	{
		wait 3;

		beamsave	= getCvar("beamsave");
		beam		= getCvar("beam");
		burn		= getCvar("burn");
	//	drug		= getCvar("drug");
		cow			= getCvar("cow");
		explode		= getCvar("explode");
		mortar		= getCvar("mortar");
		swapteam	= getCvar("swapteam");
		tospec		= getCvar("tospec");
		cvarStr		= svr\utils::cvardef("cvar", "none", "", "", "string");
		wait .20;

		crouch	= getCvar("crouch");
		disarm	= getCvar("disarm");
		lock	= getCvar("lock");
		say		= getCvar("say");
		saybold	= getCvar("saybold");
		wait .20;

		if (beamsave != "")			thread getPlayers(beamsave, "beamsave");
		else if (beam != "")		thread getPlayers(beam, "beam");
		else if (burn != "")		thread getPlayers(burn, "burn");
		else if (cow != "")			thread getPlayers(cow, "cow");
	//	else if (drug != "")		thread getPlayers(drug, "drug");
		else if (explode != "")		thread getPlayers(explode, "explode");
		else if (mortar != "")		thread getPlayers(mortar, "mortar");
		else if (swapteam != "")	thread getPlayers(swapteam, "swapteam");
		else if (tospec != "")		thread getPlayers(tospec, "tospec");
	//	else if (cvarStr != "none")	thread cvarSet(cvarStr);
		else if (crouch != "")		thread getPlayers(crouch, "crouch");
		else if (disarm != "")		thread getPlayers(disarm, "disarm");
		else if (lock != "")		thread getPlayers(lock, "lock");
		else if (say != "")			thread sayMsg(say, false, "say");
		else if (saybold != "")		thread sayMsg(saybold, true, "saybold");
	}
}

getPlayers(var, cmd)
{
	if (isDefined(level.inGetPlayers))		return;
	level.inGetPlayers = true;

	_t = undefined;

	if (var == "all" || ((var == "allies" || var == "axis") && !(cmd == "tospec" || cmd == "swapteam")))
	{
		players = getentarray("player", "classname");
		for (i = 0; i < players.size; i++)
			if (isDefined(players[i]))
			{
				_p = players[i];
				_t = _p svr\utils::getTeam();

				if (isDefined(_t))
				{
					if (var == "all")
						_p threadCmd(cmd, true);
					else if (var == _t)
						_p threadCmd(cmd, false);
				}
			}
	}
	else if (var.size <= 2)	   // maximum player slots is only 2 digits..
	{
		for (i = 0; i < var.size; i++)
			if (!svr\utils::isNumeric(var[i]))	// prevent k3#a8p as input..
			{
				setCvar(cmd, "");
				level.inGetPlayers = undefined;
				return;
			}

		_i = (int)var;

		players = getentarray("player", "classname");
		for (i = 0; i < players.size; i++)
		{
			_p = players[i];
			_e = _p getEntityNumber();

			if (_e == _i)
				_p threadCmd(cmd, false);
		}
	}

	setCvar(cmd, "");
	level.inGetPlayers = undefined;
}

threadCmd(cmd, all)
{
	if (cmd == "beamsave")		self thread beam(true);
	else if (cmd == "beam")		self thread beam(false);
	else if (cmd == "burn")		self thread burn();
	else if (cmd == "cow")		self thread cow();
//	else if (cmd == "drug")		self thread drug();
	else if (cmd == "explode")	self thread explode();
	else if (cmd == "mortar")	self thread mortar();
	else if (cmd == "swapteam")	self thread swapteam(all);
	else if (cmd == "tospec")	self thread tospec(all);
	else if (cmd == "crouch")	self thread crouch();
	else if (cmd == "disarm")	self thread disarm();
	else if (cmd == "lock")		self thread lock();
	else if (cmd == "adminspec")	self thread adminSpec();
}

beam(save)
{
	if (isPlayer(self) && isAlive(self))
	{
		if (save)	// save player position so we can teleport him later..
		{
			self.pers["beamposition"] = self.origin;
		}
		else if (isDefined(self.pers["beamposition"]))
		{
			self thread svr\utils::closeMenus();
			self setOrigin(self.pers["beamposition"]);
			self thread printMsg("beam", &"ADMIN_BEAM");
		}
	}
}

burn(noMsg)
{
	if (!isPlayer(self) || !isAlive(self))
		return;

	self endon("svrKilledPlayer");

	self thread svr\utils::closeMenus();
	if (!isDefined(noMsg))
		self thread printMsg("burn", &"ADMIN_BURN");
	self.burnedout = false;
	count = 0;
	self.health = 100;
	self thread burnDmg();

	while (self.burnedout == false)
	{
		if (count == 0)
		{
			count = 2.5;
			self thread painSounds();
		}
		else
			count -= .10;

		playfx(game["adminEffect"]["burn"], self.origin);
		wait .05;
		if (game["svrGameName"] == "cod2")
			playfx(game["adminEffect"]["burn"], self.origin);
		wait .05;
	}
	self notify("killTheFlame");

	return;
}

burnDmg()
{
	self endon("svrKilledPlayer");
	self endon("killTheFlame");

	wait 8;
	self.burnedout = true;

	if (self.sessionstate == "playing")
	{
		self.svrSpawnDelay = 0;
		self.svrSuicide = true;
		self suicide();
	}
}

cow()
{
	if (!isPlayer(self) || !isAlive(self))
		return;

	self endon("svrKilledPlayer");
	self endon("killTheFlame");

	self thread svr\utils::closeMenus();
	self thread printMsg("cow", &"ADMIN_COW");

	if (game["svrGameName"] != "cod2")
		self setmodel("xmodel/cow_standing");

	self disableWeapon();
	self thread burn(true);
	wait 7.5;
	self setmodel(game["deadCowModel"]);
}

explode()
{
	if (isPlayer(self) && isAlive(self))
	{
		self thread svr\utils::closeMenus();
		self thread printMsg("explode", &"ADMIN_EXPLODE");

		playfx(game["adminEffect"]["explode"], self.origin);
		wait .10;

		self painSounds();
		self.svrSpawnDelay = 0;
		self.svrSuicide = true;
		self suicide();
	}
}

mortar()
{
	if (!isPlayer(self) || !isAlive(self))
		return;

	self endon("svrKilledPlayer");

	self thread svr\utils::closeMenus();
	self thread printMsg("mortar", &"ADMIN_MORTAR");
	wait 1;

	self.health = 100;

	self thread playSoundAtLocation("mortar_incoming2", self.origin, 1);
	wait .75;

	while (isAlive(self) && self.sessionstate == "playing")
	{
		target = self.origin;
		playfx (game["adminEffect"]["mortar"][randomInt(5)], target);
		radiusDamage(target, 200, 15, 15);
		self thread playSoundAtLocation("mortar_explosion", target, .1 );

		if (self.health < 35)
			self setClientCvar("cl_stance", 2);	   // for cod/uo

		earthquake(0.3, 3, target, 850);
		wait 2;
	}
}

crouch()
{
	if (isPlayer(self) && !isDefined(self.adminCrouch))
	{
		self endon("disconnect");
		self notify("crouchoff");
		self endon("crouchoff");

		time = svr\utils::cvardef("svr_admincrouchtime", 10, 1, 9999, "int");
		count = 0;

		self.adminCrouch = true;
		self thread svr\utils::closeMenus();
		self thread printMsg("crouch", &"ADMIN_CROUCH");

		while (isDefined(self.adminCrouch))
		{
			while (isAlive(self) && self.sessionstate == "playing" && count < time && isDefined(self.adminCrouch))
			{
				if (self getStance() != "crouch")
					self setClientCvar("cl_stance", 1);

				count += .50;
				wait .50;
			}

			if (count >= time)
				break;

			wait .50;
		}

		self.adminCrouch = undefined;
		self thread svr\utils::closeMenus();
		self thread printMsg("crouchoff", &"ADMIN_CROUCHOFF");
	}
	else if (isPlayer(self) && isDefined(self.adminCrouch))
	{
		self.adminCrouch = undefined;
		self thread svr\utils::closeMenus();
		self thread printMsg("crouchoff", &"ADMIN_CROUCHOFF");
	}
}

disarm()
{
	if (isPlayer(self) && !isDefined(self.adminDisarm))
	{
		self endon("disconnect");
		self notify("disarmoff");
		self endon("disarmoff");

		time = svr\utils::cvardef("svr_admindisarmtime", 10, 1, 9999, "int");
		count = 0;

		self.adminDisarm = true;
		self thread svr\utils::closeMenus();
		self thread printMsg("disarm", &"ADMIN_DISARM");

		while (isDefined(self.adminDisarm))
		{
			slot = [];
			slot[0] = "primary";
			slot[1] = "primaryb";

			if (game["svrGameName"] != "cod2")
			{
				slot[2] = "pistol";
				slot[3] = "grenade";

				if (game["svrGameName"] == "uo")
				{
					slot[4] = "smokegrenade";
					slot[5] = "satchel";
					slot[6] = "binocular";
				}
			}

			while (isAlive(self) && self.sessionstate == "playing" && count < time && isDefined(self.adminDisarm))
			{
				_a = self.angles;

				for (i = 0; i < slot.size; i++)
				{
					_w = self getWeaponSlotWeapon(slot[i]);

					if (_w != "none")
						self dropItem(_w);

					self.angles = _a + (0,randomInt(30),0);
				}

				count += .50;
				wait .50;
			}

			if (count >= time)
				break;

			wait .50;
		}

		self.adminDisarm = undefined;
		self thread svr\utils::closeMenus();
		self thread printMsg("disarmoff", &"ADMIN_DISARMOFF");
	}
	else if (isPlayer(self) && isDefined(self.adminDisarm))
	{
		self.adminDisarm = undefined;
		self thread svr\utils::closeMenus();
		self thread printMsg("disarmoff", &"ADMIN_DISARMOFF");
	}
}

lock()
{
	if (isPlayer(self) && !isDefined(self.adminLock))
	{
		self endon("disconnect");
		self notify("lockoff");
		self endon("lockoff");

		time = svr\utils::cvardef("svr_adminlocktime", 10, 1, 9999, "int");
		count = 0;

		self.adminLock = true;
		self thread svr\utils::closeMenus();
		self thread printMsg("lock", &"ADMIN_LOCK");

		while (isDefined(self.adminLock))
		{
			self.anchor = spawn("script_origin", self.origin);
			self linkTo(self.anchor);
			self disableWeapon();

			while (isAlive(self) && self.sessionstate == "playing" && count < time && isDefined(self.adminLock))
			{
				count += .50;
				wait .50;
			}

			if (count >= time)
				break;

			while (self.sessionstate != "playing")
				wait .50;
		}

		self.adminLock = undefined;

		if (!isPlayer(self) || !isDefined(self.anchor))
			return;

		self thread svr\utils::closeMenus();
		self thread printMsg("lockoff", &"ADMIN_LOCKOFF");

		self unlink();
		self.anchor delete();
		self enableWeapon();
	}
	else if (isPlayer(self) && isDefined(self.adminLock))
	{
		self.adminLock = undefined;

		if (!isDefined(self.anchor))
			return;

		self unlink();
		self.anchor delete();
		self enableWeapon();

		self thread svr\utils::closeMenus();
		self thread printMsg("lockoff", &"ADMIN_LOCKOFF");
	}
}

adminSpec()
{
	if ((!isDefined(self.pers["svrIsAdmin"]) || !self.pers["svrIsAdmin"]) && (!isDefined(self.pers["svrIsClan"]) || !self.pers["svrIsClan"]))
		return;

	if (isPlayer(self) && !isDefined(self.svrAdminSpec))
	{
		if (!isDefined(self.pers["team"]) || self.pers["team"] == "spectator")
			return;

		self thread svr\utils::closeMenus();
		self thread printMsg("hide", &"ADMIN_HIDE");

		self allowSpectateTeam("allies", true);
		self allowSpectateTeam("axis", true);
		self allowSpectateTeam("freelook", true);
		self allowSpectateTeam("none", true);

		self.svrAdminSpec = true;
		self.sessionstate = "spectator";
		self.spectatorclient = -1;
		self.killcamentity = -1;
		self.archivetime = 0;
		self.psoffsettime = 0;
	//	self.statusicon = "";
	}
	else if (isPlayer(self) && isDefined(self.svrAdminSpec))
	{
		self thread svr\utils::closeMenus();
		self thread printMsg("show", &"ADMIN_SHOW");

		self thread maps\mp\gametypes\_teams::SetSpectatePermissions();
		self.svrAdminSpec = undefined;

		if (isDefined(self.pers["team"]) && self.pers["team"] != "spectator")
		{
			self.svrSpawnDelay = 0;
			self thread [[level.spawnPlayer]]();
		}
	}
}

sayMsg(msg, bold, cvar)
{
	level endon ("svrKillThread");

	setCvar(cvar, "");

	if (bold)
	{
		iprintlnbold(msg + "^7");

		time = svr\utils::cvardef("svr_adminscroll", 0, 0, 6, "float");

		if (time)
		{
			wait time;
			iprintlnbold(" "); iprintlnbold(" "); iprintlnbold(" "); iprintlnbold(" "); iprintlnbold(" ");
		}
	}
	else
		iprintln(msg + "^7");
}

swapteam(all)
{
	self endon("disconnect");

	team = undefined;
	locStr = undefined;
	gt = getCvar("g_gametype");

	self thread svr\utils::closeMenus();

	if (self.pers["team"] == "axis")
	{
		team = "allies";
		locStr = (&"ADMIN_ALLIES");
	}
	else if (self.pers["team"] == "allies")
	{
		team = "axis";
		locStr = (&"ADMIN_AXIS");
	}

	if (all)
	{
		if (game["adminLocalMsg"])
			self iprintlnbold(&"ADMIN_SWAPTEAMS");
		else
			self iprintlnbold("^3Swapping Allies-to-Axis, Axis-to-Allies^7");
	}
	else
	{
		if (game["adminLocalMsg"])
			self iprintlnbold(&"ADMIN_MOVING", locStr);
		else
			self iprintlnbold("^3You are being moved to " + team + "^7");
	}

	wait 3;

	if (self.sessionstate != "dead")
	{
		self.svrSpawnDelay = undefined;		// my mod
		self.autobalance = true;			// for uo
		self.switching_teams = true;			// for cod-2
		self.joining_team = team;				// for cod-2
		self.leaving_team = self.pers["team"];	// for cod-2
		self suicide();
	}

	self notify("end_respawn");
	self.pers["team"] = team;
	self.sessionteam = self.pers["team"];

	if (game["svrGameName"] == "uo")
		self.pers["teamTime"] = (gettime() / 1000);

	self.pers["weapon"] = undefined;
	self.pers["weapon1"] = undefined;
	self.pers["weapon2"] = undefined;
	self.pers["spawnweapon"] = undefined;
	self.pers["savedmodel"] = undefined;
	self.nextroundweapon = undefined;

	// this function is different depending on game-version..
	if (game["svrGameName"] == "uo" && (gt == "hq" || gt == "re" || gt == "sd"))
		svr\utils::specPermissions();

	self setClientCvar("ui_weapontab", "1");			// for uo
	self setClientCvar("ui_allow_weaponchange", "1");	// for cod-2
	self setClientCvar("g_scriptMainMenu", game["menu_weapon_" + team]);
	self openMenu(game["menu_weapon_" + team]);

	if (!all)
	{
		if (game["adminLocalMsg"])
			iprintln(&"ADMIN_MOVED", self, locStr);
		else
			iprintln(self.name + "^5 is being moved to " + team + "^7");
	}
}

toSpec(all)
{
	self endon("disconnect");

	if (isDefined(self.pers["svrIsBot"]))
	{
		self notify("svrBotSpectate");
		setCvar("svr_bots", 0);
	}

	if (!isDefined(self.pers["team"]) || self.pers["team"] == "spectator")
		return;

	locStr = undefined;

	self thread svr\utils::closeMenus();

	if (game["adminLocalMsg"])
	{
		locStr = (&"ADMIN_SPEC");
		self iprintlnbold(&"ADMIN_MOVING", locStr);
	}
	else
		self iprintlnbold("^3You are being moved to Spectator^7");

	wait 3;

	self thread svr\utils::closeMenus();

	// this function is different depending on game-version..
	self svr\utils::spawnSpectator();

	if (!isDefined(level.noGtSupport) && !all)
	{
		if (game["adminLocalMsg"])
			iprintln(&"ADMIN_MOVED", self, locStr);
		else
			iprintln(self.name + "^3 was moved to Spectator^7");
	}
}

painSounds()
{
	team = self svr\utils::getTeam();

	if (!isDefined(team))
	{
	//	self iprintln("in admin::painSounds, team is undefined");
		return;
	}

	if (team == "axis")
		nat = "german";
	else
		nat = "american";

	self playSound("generic_pain_" + nat + "_1");
}

printMsg(cmd, loc)
{
	if (game["adminLocalMsg"] && isDefined(loc))
		msg = loc;
	else
	{
		switch (cmd)
		{
		case "beam":	msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You've been teleported by the admin", "", "", "string");			break;
		case "burn":	msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You're being burned to death by the admin", "", "", "string");	break;
		case "drug":	msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You're being drugged by the admin", "", "", "string");			break;
		case "cow":		msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You've become bar-b-que'd beef by the admin", "", "", "string");	break;
		case "explode":	msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You've been blown to hell by the admin", "", "", "string");		break;
		case "mortar":	msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3Incoming mortar attack from the admin", "", "", "string");		break;
		//
		case "crouch":		msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You're being forced to crouch by the admin", "", "", "string");	break;
		case "crouchoff":	msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You are no longer forced to crouch", "", "", "string");	break;
		case "disarm":		msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3Your weapons have been removed by the admin", "", "", "string");	break;
		case "disarmoff":	msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You are free to use your weapons now", "", "", "string");	break;
		case "lock":		msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You've been locked by the admin", "", "", "string");		break;
		case "lockoff":		msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You've been unlocked by the admin", "", "", "string");	break;
		//
		case "hide":	msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You are a hidden spectator", "", "", "string");	break;
		case "show":	msg = svr\utils::cvardef("svr_adminmessage_" + cmd, "^3You are no longer hidden", "", "", "string");	break;
		}
	}

	if (isDefined(msg) && msg != "none")
	{
		var = svr\utils::cvardef("svr_adminmessagetype", 1, 1, 2, "int");

		if (var == 1)	self iprintln(msg);
		else			self iprintlnbold(msg);
	}
}

PlaySoundAtLocation(sound, location, iTime)
{
	org = spawn("script_model", location);
	wait 0.05;
	org show();
	org playSound(sound);
	wait iTime;
	org delete();
}
